// bookmarksync - BOOKMARK SYNC TOOL
// by Tobias Sandhaas

#include "bookmarksync.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#define BSYNC_OPT	"o:t:v"

char cReadLine[1024];
char cSpacer[64];							//spacer for output visialization
int VERBOSE=0;								//toggle for verbose

static void usage(char *pArgv) 
{
 fprintf(stderr,"usage: %s [-v] [-t mozilla1] [-o outputfile] <MasterFile> <SlaveFile>\n",pArgv);
 exit(1);
}

/* also working for mozilla v1 */
void readnetscape4(char *filename,sTree *ROOT)				//read netscape v4.x bookmarks -> struct
{									// ROOT returns new TREE
   FILE *datei= NULL;
   char *buffer, *pTmpBuffer = NULL , *p2TmpBuffer = NULL, *tmpptr;
   char cURL[1024],cDesc[1024], cLAST_CHARSET[32], cPERSONAL_TOOLBAR_FOLDER[32];
   char cID[64], cICON[1024];
   unsigned int iADD_DATE, iLAST_VISIT, iLAST_MODIFIED ;
   unsigned int bFOLDER_GROUP ;
   struct sTree *tmp = NULL ;
   struct sTree *pPos = NULL ;									// pPos is walking through the tree

   /* backup char[] */
   pTmpBuffer = (char *) malloc( 1024) ;

   pPos=ROOT;

   if ( (datei=fopen(filename,"r")) == NULL )			//File exist ?
   {
     fprintf(stderr,"Err: Cannt open %s\n",filename);
     exit(1);
   }

   while ( fgets(cReadLine,1024,datei) != NULL) 
   {
     memset(&cURL,0,sizeof(cURL));
     memset(&cDesc,0,sizeof(cDesc));
     if (tmp == NULL ) tmp=(sTree *)malloc(sizeof(sTree));
     tmp->pRoot=NULL;
	 iADD_DATE = iLAST_VISIT = iLAST_MODIFIED = 0 ;
     memset(&cLAST_CHARSET, 0, sizeof( cLAST_CHARSET ) ) ;
	 memset(&cPERSONAL_TOOLBAR_FOLDER, 0, sizeof( cPERSONAL_TOOLBAR_FOLDER ) ) ;
	 memset(&cID, 0, sizeof( cID ) ) ;
	 memset(&cICON, 0, sizeof( cICON ) ) ;
	 bFOLDER_GROUP = false ;
	
     //printf(":%s",cReadLine); 

     if ( (buffer=strstr(cReadLine,"<TITLE>")) !=0) {		// TITLE
       pPos->pRoot=NULL;
       pPos->iUsedFields=0;
       buffer=buffer+7;
       *(strchr(buffer, '<')) = '\0';
       //printf("> TITLE:%s\n",buffer);
       strcpy(cDesc,buffer);

       pPos->iUsedFields=++pPos->iUsedFields;
       pPos->Listing[pPos->iUsedFields].isDir=1;

	   //XXX kann direkt buffer verwendet werden
       strcpy(pPos->Listing[pPos->iUsedFields].cDesc,cDesc);

       pPos->Listing[pPos->iUsedFields].pTree=tmp;
       tmp->iUsedFields=0;
       tmp->pRoot=pPos;
       pPos=tmp;
       tmp=NULL; 						//erase tmp ptr
       continue;
     }

     if ( (buffer=strstr(cReadLine,"</DL>")) !=0) 		//close tree on /DL
     {
       pPos=pPos->pRoot;
       continue;
     }

     if ( (buffer=strstr(cReadLine,"<HR>")) !=0)		 //Marker tree on HR
     {             
       pPos->iUsedFields=++pPos->iUsedFields;
       pPos->Listing[pPos->iUsedFields].isMarker=1;
       pPos->Listing[pPos->iUsedFields].isDir=0;
       strcpy(pPos->Listing[pPos->iUsedFields].cURL,"");
       strcpy(pPos->Listing[pPos->iUsedFields].cDesc,"");
       continue;
     }

     if ( (buffer=strstr(cReadLine,"DT>")) !=0) {           // match DT (item to add found)
	 memset(pTmpBuffer, 0 , 1024 );
       if ( (strstr(buffer,"HREF=")) !=0) {		  	//match DT + HREF
	    /* get URL and ignore all other fields */
        buffer=strstr(buffer,"HREF");
        buffer=buffer+6;
		  tmpptr=strchr(buffer, '"');
        *tmpptr = '\0';
        strncpy(cURL,buffer, strlen(buffer));
        buffer=buffer+strlen(buffer)+1;

		memcpy(pTmpBuffer, buffer, strlen(buffer)+1 ) ;
		if ( (strstr(pTmpBuffer,"ADD_DATE=\"")) !=0) { 		
		p2TmpBuffer=strstr(pTmpBuffer,"ADD_DATE=\"");
		p2TmpBuffer=p2TmpBuffer+10;
		*(strchr(p2TmpBuffer, '"')) = '\0';
		iADD_DATE = (unsigned int) atoi(p2TmpBuffer);
		}

		memcpy(pTmpBuffer, buffer, strlen(buffer)+1 ) ;
        if ( (strstr(pTmpBuffer,"LAST_VISIT=\"")) !=0) {
        p2TmpBuffer=strstr(pTmpBuffer,"LAST_VISIT=\"");
        p2TmpBuffer=p2TmpBuffer+12;
        *(strchr(p2TmpBuffer, '"')) = '\0';
		iLAST_VISIT = (unsigned int) atoi(p2TmpBuffer);
		}

		memcpy(pTmpBuffer, buffer, strlen(buffer)+1 ) ;
        if ( (strstr(pTmpBuffer,"LAST_MODIFIED=\"")) !=0) {
        p2TmpBuffer=strstr(pTmpBuffer,"LAST_MODIFIED=\"");
        p2TmpBuffer=p2TmpBuffer+15;
        *(strchr(p2TmpBuffer, '"')) = '\0';
        iLAST_MODIFIED = (unsigned int) atoi(p2TmpBuffer);
        }

		memcpy(pTmpBuffer, buffer, strlen(buffer)+1 ) ;
        if ( (strstr(pTmpBuffer,"LAST_CHARSET=\"")) !=0) {
        p2TmpBuffer=strstr(pTmpBuffer,"LAST_CHARSET=\"");
        p2TmpBuffer=p2TmpBuffer+14;
        *(strchr(p2TmpBuffer, '"')) = '\0';
        strcpy(cLAST_CHARSET, p2TmpBuffer);
		}

        memcpy(pTmpBuffer, buffer, strlen(buffer)+1 ) ;
        if ( (strstr(pTmpBuffer,"ICON=\"")) !=0) {
        p2TmpBuffer=strstr(pTmpBuffer,"ICON=\"");
        p2TmpBuffer=p2TmpBuffer+6;
        *(strchr(p2TmpBuffer, '"')) = '\0';
        strcpy(cICON, p2TmpBuffer);
        }

        buffer=strchr(buffer,'>');			// search end of HREF statement
        buffer=buffer+1;

		/* get Description of item */
        *(strchr(buffer, '<')) = '\0';
        strcpy(cDesc,buffer);
        pPos->iUsedFields=++pPos->iUsedFields;			//ROOT durch temp wurzel von schleife zu ersetzen
        pPos->Listing[pPos->iUsedFields].isDir=0;
        strcpy(pPos->Listing[pPos->iUsedFields].cDesc, cDesc);
        strcpy(pPos->Listing[pPos->iUsedFields].cURL, cURL);
        strcpy(pPos->Listing[pPos->iUsedFields].cLAST_CHARSET, cLAST_CHARSET);
        strcpy(pPos->Listing[pPos->iUsedFields].cICON, cICON);
		pPos->Listing[pPos->iUsedFields].iLAST_MODIFIED = iLAST_MODIFIED ;
        pPos->Listing[pPos->iUsedFields].iADD_DATE = iADD_DATE ;
        pPos->Listing[pPos->iUsedFields].iLAST_VISIT = iLAST_VISIT ;
        pPos->Listing[pPos->iUsedFields].iLAST_MODIFIED = iLAST_MODIFIED ;
       }
       else {
        buffer=buffer+3;					//jump over DT>

		memcpy(pTmpBuffer, buffer, strlen(buffer)+1 ) ;
        if ( (strstr(pTmpBuffer,"ADD_DATE=\"")) !=0) {
        p2TmpBuffer=strstr(pTmpBuffer,"ADD_DATE=\"");
        p2TmpBuffer=p2TmpBuffer+10;
        *(strchr(p2TmpBuffer, '"')) = '\0';
        iADD_DATE = (unsigned int) atoi(p2TmpBuffer);
        }

        if ( (strstr(buffer,"FOLDER_GROUP=\"true")) !=0) {
		bFOLDER_GROUP = true ;
		}
		else bFOLDER_GROUP = false ;

		memcpy(pTmpBuffer, buffer, strlen(buffer)+1 ) ;
        if ( (strstr(pTmpBuffer,"LAST_MODIFIED=\"")) !=0) {
        p2TmpBuffer=strstr(pTmpBuffer,"LAST_MODIFIED=\"");
        p2TmpBuffer=p2TmpBuffer+15;
        *(strchr(p2TmpBuffer, '"')) = '\0';
        iLAST_MODIFIED = (unsigned int) atoi(p2TmpBuffer);
        }

		memcpy(pTmpBuffer, buffer, strlen(buffer)+1 ) ;
        if ( (strstr(pTmpBuffer,"PERSONAL_TOOLBAR_FOLDER=")) !=0) {
        p2TmpBuffer=strstr(pTmpBuffer,"PERSONAL_TOOLBAR_FOLDER=");
        p2TmpBuffer=p2TmpBuffer+25;
        *(strchr(p2TmpBuffer, '"')) = '\0';
		strcpy(cPERSONAL_TOOLBAR_FOLDER, p2TmpBuffer);
        }

		memcpy(pTmpBuffer, buffer, strlen(buffer)+1 ) ;
        if ( (strstr(pTmpBuffer,"ID=\"")) !=0) {
        p2TmpBuffer=strstr(pTmpBuffer,"ID=\"");
        p2TmpBuffer=p2TmpBuffer+4;
        *(strchr(p2TmpBuffer, '"')) = '\0';
        strcpy(cID, p2TmpBuffer);
        }
		
		/* get Description of item */
        buffer=strchr(buffer,'>');
        buffer=buffer+1;
        *(strchr(buffer, '<')) = '\0';
        strcpy(cDesc,buffer);
        pPos->iUsedFields=++pPos->iUsedFields;
        pPos->Listing[pPos->iUsedFields].isDir=1;
        strcpy(pPos->Listing[pPos->iUsedFields].cDesc,cDesc);
		strcpy(pPos->Listing[pPos->iUsedFields].cID, cID );
		strcpy(pPos->Listing[pPos->iUsedFields].cPERSONAL_TOOLBAR_FOLDER, cPERSONAL_TOOLBAR_FOLDER);
		strcpy(pPos->Listing[pPos->iUsedFields].cICON, cICON);
		pPos->Listing[pPos->iUsedFields].iLAST_MODIFIED = iLAST_MODIFIED ;	
		pPos->Listing[pPos->iUsedFields].iADD_DATE = iADD_DATE ;
		pPos->Listing[pPos->iUsedFields].bFOLDER_GROUP = bFOLDER_GROUP ;
        pPos->Listing[pPos->iUsedFields].pTree=tmp;
        tmp->iUsedFields=0;
        tmp->pRoot=pPos;
        pPos=tmp;						// one step down the tree
        tmp=NULL;                                                //erase tmp ptr
		continue;
       }
       continue;
     } 
   } 

   free( pTmpBuffer ) ;
   if (tmp != NULL ) free(tmp); 
   fclose(datei);
}

void output_ascii(sTree *ROOT) {				// ascii output of sTree
  for (int i=1;i<=ROOT->iUsedFields;i++) {
    if (ROOT->Listing[i].isDir==0) 
    {
      if (ROOT->Listing[i].isMarker!=1)
      {
        printf("%s - %s \"%s\"\n",cSpacer,ROOT->Listing[i].cURL,ROOT->Listing[i].cDesc);
      } else
      {
        printf("%s   ----------------------\n",cSpacer);
      }
    }     
    else 
    {
      printf("%s + %s\n",cSpacer,ROOT->Listing[i].cDesc);
      strcat(cSpacer,"  ");
      output_ascii(ROOT->Listing[i].pTree);
    }
  } 
  if (ROOT->pRoot!=NULL) 
  {
    *(cSpacer+strlen(cSpacer)-2)='\0';
  }
}


void output_mozilla_v1(sTree *ROOT,FILE *datei_out,int bHeader) 
{
  char cLine[16384] ;
  char cTmp[1024] ;

  if (bHeader) 
  {
    fprintf(datei_out,"<!DOCTYPE NETSCAPE-Bookmark-file-1>\n");
    fprintf(datei_out,"<!-- This is an automatically generated file.\n");
    fprintf(datei_out,"It will be read and overwritten.");
    fprintf(datei_out,"Do Not Edit! -->\n");
	fprintf(datei_out,"<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=UTF-8\">\n");
    fprintf(datei_out,"<TITLE>%s</TITLE>\n",ROOT->Listing[1].cDesc);  
    fprintf(datei_out,"<H1>%s</H1>\n",ROOT->Listing[1].cDesc);
    fprintf(datei_out," \n");
    fprintf(datei_out,"<DL><p>\n"); 
    ROOT=ROOT->Listing[1].pTree;
  }

  for (int i=1;i<=ROOT->iUsedFields;i++) {
    memset( &cLine, 0 , sizeof(cLine) ) ;
	memset( &cTmp, 0, sizeof(cTmp) ) ;
    if (ROOT->Listing[i].isMarker==1) 
    {
      fprintf(datei_out,"<HR>\n");
      continue;
    }
    if (ROOT->Listing[i].isDir==0)
    {
      sprintf( cLine, "    <DT><A HREF=\"%s\"", ROOT->Listing[i].cURL ) ;
      if ( ROOT->Listing[i].iADD_DATE != 0 ) {
		sprintf( cTmp, " ADD_DATE=\"%d\"", ROOT->Listing[i].iADD_DATE ) ;
		strcat( cLine, cTmp ) ;
      }
      if ( ROOT->Listing[i].iLAST_VISIT != 0 ) {
		sprintf( cTmp, " LAST_VISIT=\"%d\"", ROOT->Listing[i].iLAST_VISIT ) ;
		strcat( cLine, cTmp ) ;
      }
      if ( strlen(ROOT->Listing[i].cICON) != 0  ) {
		sprintf( cTmp, " ICON=\"%s\"", ROOT->Listing[i].cICON ) ;
		strcat( cLine, cTmp ) ;
      }
      if ( ROOT->Listing[i].iLAST_MODIFIED != 0 ) {
		sprintf( cTmp, " LAST_MODIFIED=\"%d\"", ROOT->Listing[i].iLAST_MODIFIED ) ;
		strcat( cLine, cTmp ) ;
      }
      if ( strlen(ROOT->Listing[i].cLAST_CHARSET) != 0 ) {
		sprintf( cTmp, " LAST_CHARSET=\"%s\"", ROOT->Listing[i].cLAST_CHARSET ) ;
		strcat( cLine, cTmp ) ;
      }
	  sprintf( cTmp, ">%s</A>", ROOT->Listing[i].cDesc);
	  strcat( cLine, cTmp ) ;

      fprintf(datei_out,"%s\n", cLine ) ;
    }
    else
    {
      memset( &cLine, 0 , sizeof(cLine) ) ;
	  memset( &cTmp, 0, sizeof(cTmp) ) ;
	  sprintf( cLine, "  <DT><H3 FOLDED" ) ;
      if ( ROOT->Listing[i].iADD_DATE != 0 ) {
        sprintf( cTmp, " ADD_DATE=\"%d\"", ROOT->Listing[i].iADD_DATE ) ;
        strcat( cLine, cTmp ) ;
      } 
	  if ( ROOT->Listing[i].bFOLDER_GROUP != 0 ) {
        sprintf( cTmp, " FOLDER_GROUP=\"true\"" ) ;
        strcat( cLine, cTmp ) ;
      }
      if ( ROOT->Listing[i].iLAST_MODIFIED != 0 ) {
        sprintf( cTmp, " LAST_MODIFIED=\"%d\"", ROOT->Listing[i].iLAST_MODIFIED ) ;
        strcat( cLine, cTmp ) ;
      } 
      if ( strlen(ROOT->Listing[i].cPERSONAL_TOOLBAR_FOLDER) != 0  ) {
        sprintf( cTmp, " PERSONAL_TOOLBAR_FOLDER=\"%s\"", ROOT->Listing[i].cPERSONAL_TOOLBAR_FOLDER ) ;
        strcat( cLine, cTmp ) ;
      }
      if ( strlen(ROOT->Listing[i].cID) != 0  ) {
        sprintf( cTmp, " ID=\"%s\"", ROOT->Listing[i].cID ) ;
        strcat( cLine, cTmp ) ;
      }
      sprintf( cTmp, ">%s</H3>\n<DL><p>", ROOT->Listing[i].cDesc);
      strcat( cLine, cTmp ) ;

      fprintf(datei_out,"%s\n", cLine ) ;

      output_mozilla_v1(ROOT->Listing[i].pTree,datei_out,0);
    }
  } 
  if (ROOT->pRoot!=NULL)
  {
  }
  fprintf(datei_out,"</DL><p>\n");
}

int matchEntry(char *cURL,char *cDesc,sTree *ROOT) 
{
  int value=0;
  for (int i=1;i<=ROOT->iUsedFields;i++)
  {
    if ( strncmp(ROOT->Listing[i].cDesc,cDesc, strlen(cDesc) )==0 ) {				
       value=i;
    }
  }
  return value;									//0:not found,i>=1:found in pos[i]
}

void mergeTree(sTree *RootMaster,sTree *RootSlave)
{
  sTree *pPosSlave=NULL;
  sTree *pPosMaster=NULL;
  char *cDesc=NULL;
  char *cURL=NULL;
  int iMatchNum=0;
  pPosMaster=RootMaster; //->Listing[1].pTree;
  pPosSlave=RootSlave; //->Listing[1].pTree;

  for (int i=1;i<=pPosSlave->iUsedFields;i++) 
  {
    if (pPosSlave->Listing[i].isMarker==1) continue;				//ignore Markers on merge

    cDesc=pPosSlave->Listing[i].cDesc;
    cURL=pPosSlave->Listing[i].cURL;

    if ( (iMatchNum=matchEntry(cURL,cDesc,pPosMaster)) == 0 ) 			//not found in master tree
    {
      VERBOSE_HEAD
      printf("Adding: %s\n",cDesc);
      VERBOSE_TAIL
      pPosMaster->iUsedFields=++pPosMaster->iUsedFields;
	  memset ( &pPosMaster->Listing[pPosMaster->iUsedFields], 0 , sizeof(sEntry) ) ;

      if (pPosSlave->Listing[i].isDir==0)					//no dir
      {
        strcpy(pPosMaster->Listing[pPosMaster->iUsedFields].cURL,cURL);
        strcpy(pPosMaster->Listing[pPosMaster->iUsedFields].cDesc,cDesc);
        strcpy(pPosMaster->Listing[pPosMaster->iUsedFields].cLAST_CHARSET, pPosSlave->Listing[i].cLAST_CHARSET );
        strcpy(pPosMaster->Listing[pPosMaster->iUsedFields].cICON, pPosSlave->Listing[i].cICON );
		pPosMaster->Listing[pPosMaster->iUsedFields].iADD_DATE = pPosSlave->Listing[i].iADD_DATE ;
		pPosMaster->Listing[pPosMaster->iUsedFields].iLAST_VISIT = pPosSlave->Listing[i].iLAST_VISIT ;

      }
      else 									//else dir
      {
        pPosMaster->Listing[pPosMaster->iUsedFields].isDir=1;
        pPosMaster->Listing[pPosMaster->iUsedFields].pTree=pPosSlave->Listing[i].pTree;
        strcpy(pPosMaster->Listing[pPosMaster->iUsedFields].cDesc, cDesc);
        strcpy(pPosMaster->Listing[pPosMaster->iUsedFields].cID, pPosSlave->Listing[i].cID);
        strcpy(pPosMaster->Listing[pPosMaster->iUsedFields].cPERSONAL_TOOLBAR_FOLDER, pPosSlave->Listing[i].cPERSONAL_TOOLBAR_FOLDER);
		pPosMaster->Listing[pPosMaster->iUsedFields].iLAST_MODIFIED = pPosSlave->Listing[i].iLAST_MODIFIED ;
		pPosMaster->Listing[pPosMaster->iUsedFields].iADD_DATE = pPosSlave->Listing[i].iADD_DATE ;
		pPosMaster->Listing[pPosMaster->iUsedFields].bFOLDER_GROUP = pPosSlave->Listing[i].bFOLDER_GROUP ;
      }
    }
    else 									//found item in master tree
    {
      if (pPosSlave->Listing[i].isDir==0)                                       //no dir
      {
        VERBOSE_HEAD
        printf("matched file: %s\n",cDesc);
        VERBOSE_TAIL

		if ( pPosMaster->Listing[iMatchNum].iLAST_VISIT < pPosSlave->Listing[i].iLAST_VISIT )
			pPosMaster->Listing[iMatchNum].iLAST_VISIT = pPosSlave->Listing[i].iLAST_VISIT ;

      } 
      else 									//else dir
      {
        if (pPosSlave->Listing[i].isDir==1 && pPosMaster->Listing[iMatchNum].isDir==1) 
        {
          VERBOSE_HEAD
          printf("matched dir: %s\n",cDesc);
          VERBOSE_TAIL

		  if ( pPosMaster->Listing[iMatchNum].iLAST_MODIFIED < pPosSlave->Listing[i].iLAST_MODIFIED )
            pPosMaster->Listing[iMatchNum].iLAST_MODIFIED = pPosSlave->Listing[i].iLAST_MODIFIED ;

          mergeTree(pPosMaster->Listing[iMatchNum].pTree,pPosSlave->Listing[i].pTree);
          continue;
        } 
      }
    }
  }  
}

void sortTree(sTree *ROOT)
{
//not yet implemented
}

//##########################################################
int main(int argc, char **argv) {
 struct sTree *RootMaster=NULL;
 struct sTree *RootSlave=NULL;
 struct sTree *RootMerge=NULL;
 FILE *datei_out=NULL;
 char outputtype[16];
 extern char *optarg;
 extern int optind;
 int iMainOption;

 RootMaster=(sTree *) malloc(sizeof(sTree)); 
 RootSlave=(sTree *) malloc(sizeof(sTree));
 RootMerge=(sTree *) malloc(sizeof(sTree));
 memset(&cSpacer,0,sizeof(cSpacer));
 strcpy(cSpacer," ");
 snprintf(outputtype,16, "mozilla_v1");
 printf("Welcome to bookmarksync (%s) written by Sandhaas Tobias (sourceforge@ownz.de)\n\n",VERSION);

 if (argc<3 ) { usage(argv[0]); }		//check arguments
 while ((iMainOption = getopt(argc,argv,BSYNC_OPT)) != -1 )
 {
   switch(iMainOption)
   {
     case 'v':
       printf("Verbose:     ON\n") ;
       VERBOSE=1;
       break ;
     case 't':
       // old flag. cleanup in feature versions
 	   if ( strcmp( optarg, "netscapev4" ) == 0 ) snprintf(outputtype,16,"mozilla_v1");
  		else snprintf(outputtype,16, "mozilla_v1");
       VERBOSE=0;
       break ;
     case 'o':
       if ( (datei_out=fopen(optarg,"wt")) == NULL )                   //File exist ?
       {
           fprintf(stderr,"Err: Cannot write %s\n",optarg);
           exit(1);
       }
       printf("Outputfile:  %s\n", optarg ) ;
       break ;
     default:
       usage(argv[0]) ;
   } 
 }

 if (argv[optind+1]==NULL || argv[optind]==NULL )
 { 
   fprintf(stderr,"Err: Cannot find bookmark files\n");
   exit(1);
 }

 if (datei_out==NULL) {
	if ( (datei_out=fopen("bookmarksync.html","wt")) == NULL )                   //File exist ?
	{ 
		fprintf(stderr,"Err: Cannot write bookmarksync.html \n");
		exit(1);
	}
	printf("Outputfile:  bookmarksync.html\n" ) ;
 }

 printf("Outputformat: %s\n", outputtype ) ;
 printf("Masterfile:  %s\n", argv[optind] ) ;
 VERBOSE_HEAD
 printf("constructing Tree for %s\n",argv[optind]);
 VERBOSE_TAIL
 readnetscape4(argv[optind],RootMaster); 
 VERBOSE_HEAD
 output_ascii(RootMaster);
 VERBOSE_TAIL

 printf("Slavefile:   %s\n\n", argv[optind+1] ) ;
 VERBOSE_HEAD
 printf("constructing Tree for %s\n",argv[optind+1]);
 VERBOSE_TAIL
 readnetscape4(argv[optind+1],RootSlave);
 VERBOSE_HEAD
 output_ascii(RootSlave);
 VERBOSE_TAIL

 VERBOSE_HEAD
 printf("merging\n");
 VERBOSE_TAIL
 mergeTree(RootMaster->Listing[1].pTree,RootSlave->Listing[1].pTree);

 VERBOSE_HEAD
 printf("sorting\n");
 VERBOSE_TAIL
 sortTree(RootMaster);

 VERBOSE_HEAD
 printf("output\n");
 output_ascii(RootMaster);
 VERBOSE_TAIL
 output_mozilla_v1(RootMaster,datei_out,1);

 free(RootMaster);free(RootSlave);
 fclose(datei_out);
}  //end main
